#include "random.h"
#include <cassert>
#include <cstring>

using namespace std;          

int n,cnt;
char s[1000][1000];
char t[1000][1000];

int main(int argc,char** argv){
	
	assert(argc >= 2);
	assert(scanf("%d",&n)==1);
	for (int i = 0; i < n; i++){
		assert(scanf("%s",s[i]) == 1);
		assert((int)strlen(s[i]) == n);
	}
	
	int dlt;
	assert(sscanf(argv[1],"%d",&dlt) == 1);
	printf("%d\n",n);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) 
			if (i < dlt || j < dlt || i >= n - dlt || j >= n - dlt)
				printf("%c", ((i ^ j) & 1) ? 'B' : 'W');
			else
				printf("%c", s[i][j]);
		printf("\n");
	}

	return 0;
}
